package com.wyattjmiller.conversionapp

// Android imports
import android.os.Bundle
import android.util.Log
import android.view.View
import android.widget.EditText
import android.widget.TextView
import android.widget.Toast
import androidx.appcompat.app.AppCompatDelegate
import androidx.appcompat.app.AppCompatActivity

// General Java imports
import java.lang.Exception

class MainActivity : AppCompatActivity() {

    //  Wyatt J. Miller
    //  ISYS 221 - VL1
    //  Assignment #2 – Unit Convert App Application
    //  Due: 9/13/2020

    // Private member variables
    private var mEuroAmountEditText: EditText? = null
    private var mKilometersEditText: EditText? = null
    private var mDollarsTextView: TextView? = null
    private var mMilesTextView: TextView? = null

    // The following methods are for keeping track of the Android lifecycle using Logcat
    // Very useful, much wow
    // Android's lifecycle is so much fun lol :P
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        AppCompatDelegate.setDefaultNightMode(AppCompatDelegate.MODE_NIGHT_FOLLOW_SYSTEM)
        mEuroAmountEditText = findViewById(R.id.eurosEditText)
        mKilometersEditText = findViewById(R.id.kiloEditText)
        mDollarsTextView = findViewById(R.id.dollarTextView)
        mMilesTextView = findViewById(R.id.milesTextView)
    }

    override fun onStart() {
        Log.d("LIFECYCLE", "onStart invoked!")
        super.onStart()
    }

    override fun onResume() {
        Log.d("LIFECYCLE", "onResume invoked!")
        super.onResume()
    }

    override fun onPause() {
        Log.d("LIFECYCLE", "onPause invoked!")
        super.onPause()
    }

    override fun onStop() {
        Log.d("LIFECYCLE", "onStop invoked!")
        super.onStop()
    }

    override fun onDestroy() {
        Log.d("LIFECYCLE", "onDestroy invoked!")
        super.onDestroy()
    }

    // calculateEuroClick method that calculates the Euro input and gives Dollar conversion
    fun calculateEuroClick(view: View?) {
        try {
            val euroDouble = mEuroAmountEditText!!
                    .text
                    .toString()
                    .toDouble()

            val conv = Conversion(euroResponse = euroDouble)
            val dollarsResponse = conv.euroToDollars
            val dollarsText = "US Dollars: $${String.format("%.2f", dollarsResponse)}"
            mDollarsTextView!!.text = dollarsText
        } catch (e: Exception) {
            Toast.makeText(this, "Please enter Euros", Toast.LENGTH_LONG).show()
        }
    }

    // calculateKilo method that calculates the Kilo input and gives Miles conversion
    fun calculateKiloClick(view: View?) {
        try {
            val kiloDouble = mKilometersEditText!!
                    .text
                    .toString()
                    .toDouble()

            val conv = Conversion(kiloResponse = kiloDouble)
            val milesResponse = conv.kiloToMiles
            val milesText = "Miles: $milesResponse"
            mMilesTextView!!.text = milesText
        } catch (e: Exception) {
            Toast.makeText(this, "Please enter Kilometers", Toast.LENGTH_LONG).show()
        }
    }
}